unit FormTeeGrid_DEBUG;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Param,
  FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf, FireDAC.DApt.Intf,
  Data.DB, FireDAC.Comp.DataSet, FireDAC.Comp.Client, FireDAC.Stan.StorageXML,
  Tee.Grid,
  //Lib_GridEx,

  Tee.Grid.Header,
  FMXTee.Control,
  FMXTee.Grid, FireDAC.Stan.StorageBin;

type
  TForm2 = class(TForm)
    FDStanStorageXMLLink1: TFDStanStorageXMLLink;
    FDMemTable1: TFDMemTable;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
const
  SAMPLE_XML = 'sample.xml';

implementation

{$R *.fmx}

procedure TForm2.FormCreate(Sender: TObject);
var
  DataGrid:TTeeGrid;
  I: Integer;
  dt:TFieldType;

  function CreateSortable:TSortableHeader;
  begin
    result:=TSortableHeader.Create(DataGrid.Header.Changed);
    // cosmetic example
    result.Format.Brush.Color := TColors.Green;
    result.Format.Stroke.Show;
  end;

begin
     // Open demo data
     FDMemTable1.LoadFromFile('..\..\'+SAMPLE_XML);
     FDMemTable1.Open;
     // id_gt_agencia is ftSmallint
     // Set all fields writable
     for I := 0 to FDMemTable1.Fields.Count-1 do begin
      FDMemTable1.Fields[i].ReadOnly := False;
      FDMemTable1.Fields[i].ProviderFlags := [];//[TProviderFlag.pfInUpdate];
     end;




     // Create Grid
     DataGrid        := TTeeGrid.Create(self);
     DataGrid.Parent := Self;
     DataGrid.Align  := TAlignLayout.Client;

     // Config grid

     // No funciona en Seattle ni Tokyo
     // STEEMA When True, moving from one cell to another will keep the cell editor visible
     //BUG-> DataGrid.Editing.AlwaysVisible := True; //<- BUG When True show editor, but the cell is NOT editable.

     // STEEMA When True, pressing any key will show the cell editor automatically.
     // STEEMA When False, only pressing F2 or double-clicking the cell starts editing.
     DataGrid.Editing.AutoEdit      := True;
     //  moves to the next cell on the right?.
     DataGrid.Editing.EnterKey      := TEditingEnter.NextCell;//NextRow;

     // STEEMA Do not show cell editor with all text selected by default
     DataGrid.Editing.Text.Selected := False;

     // Allow sort if Data is TVirtualFDDatasetData
     {
     DataGrid.Header.Sortable   := True;
     DataGrid.Header.SortRender :=  CreateSortable();
     }

     // Asociate FDMemTable
     //DataGrid.Data  := TVirtualFDDatasetData.From(FDMemTable1);
     DataGrid.DataSource := FDMemTable1;


end;

end.
